
#include "stm32f1xx_hal.h"

#ifndef M95M01
#define M95M01

#define CMD_WRSR   0x01  // write status register
#define CMD_WRITE  0x02  // write to EEPROM
#define CMD_READ   0x03  // read from EEPROM
#define CMD_WRDI   0x04  // write disable
#define CMD_RDSR   0x05  // read status register
#define CMD_WREN   0x06  // write enable

#define BIT_WIP    0x01	 // write in progress
#define BIT_WEL    0x02	 // write enable latch
#define BIT_BP0    0x04	 // block protect 0
#define BIT_BP1    0x08	 // block protect 1
#define BIT_SRWD   0x80	// status register write disable

#define PAGESIZE 128


int EE_Init(SPI_HandleTypeDef *hspimain);
int	EE_GetRegisterValue(unsigned char cmd, unsigned char * pReadData, int iNum);
int EE_Read(unsigned long address, char *pBuffer, unsigned int iLength);
int EE_Write(unsigned long address, char *pBuffer, unsigned int iLength);
int EE_Wait_WIP(void);
uint32_t page(uint32_t address);
uint8_t page_address(uint32_t address);

#endif  
